from machine import Pin
import utime

def setup(pins):
    out1 = Pin(pins[0], Pin.OUT)
    out2 = Pin(pins[1], Pin.OUT)
    out3 = Pin(pins[2], Pin.OUT)
    out4 = Pin(pins[3], Pin.OUT)
    out1.value(0)
    out2.value(0)
    out3.value(0)
    out4.value(0)
    utime.sleep_us(1500)
    
    return [out1, out2, out3, out4]

def setStepper(seq, out):
    out[0].value(seq[0])
    out[1].value(seq[1])
    out[2].value(seq[2])
    out[3].value(seq[3])
    utime.sleep_us(1500)
    

def setStepperOff(out):
    setStepper([0,0, 0, 0], out)
    

def setStepperOn(seq_pos, seq, out):
    setStepper(seq[seq_pos], out)
    
def avs_sequenz():
    seq1 = (1, 0, 1, 0)
    seq2 = (0, 1, 1, 0)
    seq3 = (0, 1, 0, 1)
    seq4 = (1, 0, 0, 1)
    
    return [seq1, seq2, seq3, seq4]

def forwardStep(steps, seq_pos, seq, out):
    
    xi = 0
    while xi < steps:
        xi = xi + 1
        seq_pos = seq_pos + 1
        
        if seq_pos == len(seq):
            seq_pos = 0
            
        setStepper(seq[seq_pos], out)
        
    return seq_pos


def backwardStep(steps, seq_pos, seq, out):
    
    xi = 0
    while xi < steps:
        xi = xi + 1
        
        seq_pos = seq_pos - 1
        
        if seq_pos < 0:
            seq_pos = len(seq)-1    
            
        setStepper(seq[seq_pos], out)
        
    return seq_pos